/*
 * SampaEngine.java
 *
 * Created on 11 stycze 2005, 12:16
 */

package jsampa;

/**
 *
 * @author michalus
 */
import java.util.Stack;
import java.util.Vector;

/*
 * Created on 2004-12-13
 */

/**
 * @author michalus
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class SampaEngine {
    
    /** Zarzadca regul przechowujaca wszystkie reguly*/
    private ZarzadcaRegul reguly;
    
    /** Tworzy nowy silnik transkrypcji, mozna do niego dodawac nowe reguly
     * oraz transkrybowac za ich pomoca ciagi znakow
     */
    public SampaEngine() {
        
        reguly = new ZarzadcaRegul();   //nowy zarzadca regul, do niego dodawane sa reguly
        
        //reguly.add(new Regula(" ", new String[]{"_"}));
        
        reguly.add(new Regula("rz", new String[]{"Z"}));
        reguly.add(new Regula("si", new String[]{"s'", "e"}));
        reguly.add(new Regula("", new String[]{"ts'"}));
        reguly.add(new Regula("prz", new String[]{"p", "S"}));
        
        reguly.add(new Regula("lian", new String[]{"l", "j", "a", "n"}));
        
        reguly.add(new Regula(0, "dzi ", new String[]{"dz", "i", "_"}, 3, 10));
        
        //reguly.add(new Regula("n ", new String[]{"n", "om"}, 2));
        //reguly.add(new Regula(-1, "w", new String[]{"f"}, 1));
        reguly.add(new Regula("w", new String[]{"s'", "f"}));
        // ---
        
        reguly.add(new Regula("i", new String[]{"i"}));
        reguly.add(new Regula("y", new String[]{"I"}));
        reguly.add(new Regula("e", new String[]{"e"}));
        reguly.add(new Regula("a", new String[]{"a"}));
        reguly.add(new Regula("e", new String[]{"e"}));
        reguly.add(new Regula("o", new String[]{"o"}));
        reguly.add(new Regula("", new String[]{"u"}));
        reguly.add(new Regula("u", new String[]{"u"}));
        reguly.add(new Regula("", new String[]{"e~"}));
        reguly.add(new Regula("", new String[]{"a~"}));
        
        reguly.add(new Regula("p", new String[]{"p"}));
        reguly.add(new Regula("b", new String[]{"b"}));
        reguly.add(new Regula("t", new String[]{"t"}));
        reguly.add(new Regula("d", new String[]{"d"}));
        reguly.add(new Regula("k", new String[]{"k"}));
        reguly.add(new Regula("g", new String[]{"g"}));
        reguly.add(new Regula("f", new String[]{"f"}));
        reguly.add(new Regula("w", new String[]{"v"}));
        reguly.add(new Regula("s", new String[]{"s"}));
        reguly.add(new Regula("z", new String[]{"z"}));
        
        reguly.add(new Regula("sz", new String[]{"S"}));
        reguly.add(new Regula("", new String[]{"Z"}));
        reguly.add(new Regula("", new String[]{"s'"}));
        reguly.add(new Regula("", new String[]{"z'"}));
        reguly.add(new Regula("h", new String[]{"x"}));
        reguly.add(new Regula("ch", new String[]{"x"}));
        reguly.add(new Regula("c", new String[]{"ts"}));
        reguly.add(new Regula("dz", new String[]{"dz"}));
        reguly.add(new Regula("cz", new String[]{"tS"}));
        reguly.add(new Regula("d", new String[]{"dz'"}));
        
        reguly.add(new Regula("d", new String[]{"dZ"})); // ??? tak jest d?
        reguly.add(new Regula("", new String[]{"ts'"})); // ??? tak jest ?
        
        reguly.add(new Regula("m", new String[]{"m"}));
        reguly.add(new Regula("n", new String[]{"n"}));
        reguly.add(new Regula("", new String[]{"n'"}));
        // reguly.add(new Regula("N", "")); N		p?k			peNk
        reguly.add(new Regula("l", new String[]{"l"}));
        reguly.add(new Regula("r", new String[]{"r"}));
        reguly.add(new Regula("", new String[]{"w"}));
        reguly.add(new Regula("j", new String[]{"j"}));
        
        //z prostych regul
        
                /*
                 * Liter i przed samogosk wymawia si jako:
                 * /j/ po zwartych, nosowej /m/, trcych /f,v,x/, i goskach /l,r/
                 * /i/ na kocu wyrazu
                 * podwjne ii po zwartych, nosowej /m/, trcych /f,v/, goskach /l,r/ i literze ch wymawia  si jako /ji/
                 */
        //reguly.add(new Regula("ia", "ja"));
        //reguly.add(new Regula("ie", "je"));
        //reguly.add(new Regula("io", "jo"));
        //reguly.add(new Regula("iu", "ju"));
        //reguly.add(new Regula("iy", "jy"));
        
        reguly.add(new Regula("mii", new String[]{"m", "j", "i"}));
        reguly.add(new Regula("fii", new String[]{"f", "j", "i"}));
        reguly.add(new Regula("wii", new String[]{"v", "j", "i"}));
        reguly.add(new Regula("lii", new String[]{"l", "j", "i"}));
        reguly.add(new Regula("rii", new String[]{"r", "j", "i"}));
        reguly.add(new Regula("chii", new String[]{"x", "j", "i"}));
        
                /*
                 * Nastpujce grupy spgoska-samogoska /i/ odpowiadaj nastpujcym fonemom:
                 * si  /s/           ci - /ts/
                 * zi  /z/           dzi - /dz/
                 * ni - /n/  wyjtek Dania /danja/, ale /dana/
                 */
        
        reguly.add(new Regula("si", new String[]{"s'"}));
        reguly.add(new Regula("zi", new String[]{"z'"}));
        reguly.add(new Regula("dzi", new String[]{"dz'"}));
        reguly.add(new Regula("ni", new String[]{"n'"}));
        reguly.add(new Regula("ci", new String[]{"ts'"}));
        reguly.add(new Regula("dania", new String[]{"d", "a", "n", "j", "a"}));
        
                /*
                 * Samogoski nosowe , wymawia si jako
                 * /e~,o~/ na kocu wyrazu
                 * /em,om/ przed /p,b/
                 * /en,on/ przed /t,d,ts,tS,dz,dZ/
                 * /en,on/ przed /ts,dz/
                 * /eN,oN/ przed /k,g/
                 * /e,o/ przed /l,w/ wziem  w czasie przeszym
                 */
        
        reguly.add(new Regula(0, " ", new String[]{"e~"}, 1, 10));
        reguly.add(new Regula(0, " ", new String[]{"o", "m"}, 1, 10));
        
        reguly.add(new Regula("p", new String[]{"e", "m", "p"}));
        reguly.add(new Regula("b", new String[]{"e", "m", "b"}));
        reguly.add(new Regula("p", new String[]{"o", "m", "p"}));
        reguly.add(new Regula("b", new String[]{"o", "m", "b"}));
        
        reguly.add(new Regula("t", new String[]{"e", "n", "t"}));
        reguly.add(new Regula("d", new String[]{"e", "n", "d"}));
        reguly.add(new Regula("c", new String[]{"e", "n", "ts"}));
        reguly.add(new Regula("cz", new String[]{"e", "n", "tS"}));
        reguly.add(new Regula("dz", new String[]{"e", "n", "dz"}));
        reguly.add(new Regula("d", new String[]{"e", "n", "dZ"}));
        
        reguly.add(new Regula("t", new String[]{"o", "n", "t"}));
        reguly.add(new Regula("d", new String[]{"o", "n", "d"}));
        reguly.add(new Regula("c", new String[]{"o", "n", "ts"}));
        reguly.add(new Regula("cz", new String[]{"o", "n", "tS"}));
        reguly.add(new Regula("dz", new String[]{"o", "n", "dz"}));
        reguly.add(new Regula("d", new String[]{"o", "n", "dZ"}));
        
        reguly.add(new Regula("k", new String[]{"e", "N", "k"}));
        reguly.add(new Regula("g", new String[]{"e", "N", "g"}));
        reguly.add(new Regula("k", new String[]{"o", "N", "k"}));
        reguly.add(new Regula("g", new String[]{"o", "N", "g"}));
        
        reguly.add(new Regula("", new String[]{"o", "w"}));
        reguly.add(new Regula("l", new String[]{"e", "l"}));
        
                /*
                 * Goski zwarte (/b,d,g/), zwarto-trce (/dz,dz,dZ/) i trce (/v,z,z,Z/) wymwione
                 * przed goskami bezdwicznymi, przerw(w wygosie) staj si bezdwicznymi i
                 * ich wymowa jest dokadna, jak ich bezdwicznych odpowiednikw, tj. /p,t,k/, /ts,ts,tS/
                 * czy /f,s,s,S/. To samo wystpuje u zbiegu wyrazw wymwionych bez przerwy
                 */
        
        // bezdzwieczne "t", "p", "f", "s", "k", "c", "sz, cz, ch, , 
        // dzwieczne d, b, w, z, g, dz, , d, j, , r, l, m, n, , , d, a, o, e, i, u, , , y
        
        reguly.add(new Regula(" t", new String[]{"S"}, 1));
        reguly.add(new Regula(" p", new String[]{"S"}, 1));
        reguly.add(new Regula(" f", new String[]{"S"}, 1));
        reguly.add(new Regula(" s", new String[]{"S"}, 1));
        reguly.add(new Regula(" k", new String[]{"S"}, 1));
        reguly.add(new Regula(" c", new String[]{"S"}, 1));
        reguly.add(new Regula(" sz", new String[]{"S"}, 1));
        reguly.add(new Regula(" cz", new String[]{"S"}, 1));
        reguly.add(new Regula(" ch", new String[]{"S"}, 1));
        reguly.add(new Regula(" ", new String[]{"S"}, 1));
        reguly.add(new Regula(" ", new String[]{"S"}, 1));
        
        reguly.add(new Regula(" t", new String[]{"s'"}, 1));
        reguly.add(new Regula(" p", new String[]{"s'"}, 1));
        reguly.add(new Regula(" f", new String[]{"s'"}, 1));
        reguly.add(new Regula(" s", new String[]{"s'"}, 1));
        reguly.add(new Regula(" k", new String[]{"s'"}, 1));
        reguly.add(new Regula(" c", new String[]{"s'"}, 1));
        reguly.add(new Regula(" sz", new String[]{"s'"}, 1));
        reguly.add(new Regula(" cz", new String[]{"s'"}, 1));
        reguly.add(new Regula(" ch", new String[]{"s'"}, 1));
        reguly.add(new Regula(" ", new String[]{"s'"}, 1));
        reguly.add(new Regula(" ", new String[]{"s'"}, 1));
        
        reguly.add(new Regula("z t", new String[]{"s"}, 1));
        reguly.add(new Regula("z p", new String[]{"s"}, 1));
        reguly.add(new Regula("z f", new String[]{"s"}, 1));
        reguly.add(new Regula("z s", new String[]{"s"}, 1));
        reguly.add(new Regula("z k", new String[]{"s"}, 1));
        reguly.add(new Regula("z c", new String[]{"s"}, 1));
        reguly.add(new Regula("z sz", new String[]{"s"}, 1));
        reguly.add(new Regula("z cz", new String[]{"s"}, 1));
        reguly.add(new Regula("z ch", new String[]{"s"}, 1));
        reguly.add(new Regula("z ", new String[]{"s"}, 1));
        reguly.add(new Regula("z ", new String[]{"s"}, 1));
        
        reguly.add(new Regula("w t", new String[]{"f"}, 1));
        reguly.add(new Regula("w p", new String[]{"f"}, 1));
        reguly.add(new Regula("w f", new String[]{"f"}, 1));
        reguly.add(new Regula("w s", new String[]{"f"}, 1));
        reguly.add(new Regula("w k", new String[]{"f"}, 1));
        reguly.add(new Regula("w c", new String[]{"f"}, 1));
        reguly.add(new Regula("w sz", new String[]{"f"}, 1));
        reguly.add(new Regula("w cz", new String[]{"f"}, 1));
        reguly.add(new Regula("w ch", new String[]{"f"}, 1));
        reguly.add(new Regula("w ", new String[]{"f"}, 1));
        reguly.add(new Regula("w ", new String[]{"f"}, 1));
        
        reguly.add(new Regula("b t", new String[]{"p"}, 1));
        reguly.add(new Regula("b p", new String[]{"p"}, 1));
        reguly.add(new Regula("b f", new String[]{"p"}, 1));
        reguly.add(new Regula("b s", new String[]{"p"}, 1));
        reguly.add(new Regula("b k", new String[]{"p"}, 1));
        reguly.add(new Regula("b c", new String[]{"p"}, 1));
        reguly.add(new Regula("b sz", new String[]{"p"}, 1));
        reguly.add(new Regula("b cz", new String[]{"p"}, 1));
        reguly.add(new Regula("b ch", new String[]{"p"}, 1));
        reguly.add(new Regula("b ", new String[]{"p"}, 1));
        reguly.add(new Regula("b ", new String[]{"p"}, 1));
        
        reguly.add(new Regula("d t", new String[]{"t"}, 1));
        reguly.add(new Regula("d p", new String[]{"t"}, 1));
        reguly.add(new Regula("d f", new String[]{"t"}, 1));
        reguly.add(new Regula("d s", new String[]{"t"}, 1));
        reguly.add(new Regula("d k", new String[]{"t"}, 1));
        reguly.add(new Regula("d c", new String[]{"t"}, 1));
        reguly.add(new Regula("d sz", new String[]{"t"}, 1));
        reguly.add(new Regula("d cz", new String[]{"t"}, 1));
        reguly.add(new Regula("d ch", new String[]{"t"}, 1));
        reguly.add(new Regula("d ", new String[]{"t"}, 1));
        reguly.add(new Regula("d ", new String[]{"t"}, 1));
        
        reguly.add(new Regula("g t", new String[]{"k"}, 1));
        reguly.add(new Regula("g p", new String[]{"k"}, 1));
        reguly.add(new Regula("g f", new String[]{"k"}, 1));
        reguly.add(new Regula("g s", new String[]{"k"}, 1));
        reguly.add(new Regula("g k", new String[]{"k"}, 1));
        reguly.add(new Regula("g c", new String[]{"k"}, 1));
        reguly.add(new Regula("g sz", new String[]{"k"}, 1));
        reguly.add(new Regula("g cz", new String[]{"k"}, 1));
        reguly.add(new Regula("g ch", new String[]{"k"}, 1));
        reguly.add(new Regula("g ", new String[]{"k"}, 1));
        reguly.add(new Regula("g ", new String[]{"k"}, 1));
        
        reguly.add(new Regula("dz t", new String[]{"ts"}, 2));
        reguly.add(new Regula("dz p", new String[]{"ts"}, 2));
        reguly.add(new Regula("dz f", new String[]{"ts"}, 2));
        reguly.add(new Regula("dz s", new String[]{"ts"}, 2));
        reguly.add(new Regula("dz k", new String[]{"ts"}, 2));
        reguly.add(new Regula("dz c", new String[]{"ts"}, 2));
        reguly.add(new Regula("dz sz", new String[]{"ts"}, 2));
        reguly.add(new Regula("dz cz", new String[]{"ts"}, 2));
        reguly.add(new Regula("dz ch", new String[]{"ts"}, 2));
        reguly.add(new Regula("dz ", new String[]{"ts"}, 2));
        reguly.add(new Regula("dz ", new String[]{"ts"}, 2));
        
        reguly.add(new Regula("d t", new String[]{"tS"}, 2));
        reguly.add(new Regula("d p", new String[]{"tS"}, 2));
        reguly.add(new Regula("d f", new String[]{"tS"}, 2));
        reguly.add(new Regula("d s", new String[]{"tS"}, 2));
        reguly.add(new Regula("d k", new String[]{"tS"}, 2));
        reguly.add(new Regula("d c", new String[]{"tS"}, 2));
        reguly.add(new Regula("d sz", new String[]{"tS"}, 2));
        reguly.add(new Regula("d cz", new String[]{"tS"}, 2));
        reguly.add(new Regula("d ch", new String[]{"tS"}, 2));
        reguly.add(new Regula("d ", new String[]{"tS"}, 2));
        reguly.add(new Regula("d ", new String[]{"tS"}, 2));
        
        reguly.add(new Regula("d t", new String[]{"ts'"}, 2));
        reguly.add(new Regula("d p", new String[]{"ts'"}, 2));
        reguly.add(new Regula("d f", new String[]{"ts'"}, 2));
        reguly.add(new Regula("d s", new String[]{"ts'"}, 2));
        reguly.add(new Regula("d k", new String[]{"ts'"}, 2));
        reguly.add(new Regula("d c", new String[]{"ts'"}, 2));
        reguly.add(new Regula("d sz", new String[]{"ts'"}, 2));
        reguly.add(new Regula("d cz", new String[]{"ts'"}, 2));
        reguly.add(new Regula("d ch", new String[]{"ts'"}, 2));
        reguly.add(new Regula("d ", new String[]{"ts'"}, 2));
        reguly.add(new Regula("d ", new String[]{"ts'"}, 2));
        
        reguly.add(new Regula(0, ".", new String[]{"."}, 1, 100));
        reguly.add(new Regula(0, ",", new String[]{","}, 1, 100));
        reguly.add(new Regula(0, "?", new String[]{"?"}, 1, 100));
        reguly.add(new Regula(0, "!", new String[]{"!"}, 1, 100));
        
                /*
                 * O ubezdwicznieniu lub udwicznieniu caej sekwencji powyszych spgosek o rnym
                 * typie pobudzenia decyduje w zasadzie ostatnia w sekwencji goska  np. liczba - /lidZba/,
                 * rzadszy - /Zat_SI/
                 */
        
                /*
                 * Goski zwarte (/b,d,g/), zwarto-trce (/dz,dz,dZ/) i trce (/v,z,z,Z/) wymwione przed
                 * goskami bezdwicznymi, przerw(w wygosie) staj si bezdwicznymi i ich wymowa jest
                 * dokadna, jak ich bezdwicznych odpowiednikw, tj. /p,t,k/, /ts,ts,tS/ czy /f,s,s,S/.
                 * To samo wystpuje u zbiegu wyrazw wymwionych bez przerwy
                 */
        
                /*
                 * O ubezdwicznieniu lub udwicznieniu caej sekwencji powyszych spgosek o rnym
                 * typie pobudzenia decyduje w zasadzie ostatnia w sekwencji goska  np. liczba - /lidZba/,
                 * rzadszy - /Zat_SI/
                 */
        
                /*
                 * Od powyszej zasady jest wyjtek, gdy przed liter w lub sekwencj rz stoi goska
                 * bezdwiczna. Caa sekwencja staje si bezdwiczna. np. kwiat  /kfjat/,
                 * szwaczka - /SfatSka/
                 */
        
                /*
                 * Nieregularnoci w wymowie trz, drz, d, dz w obrbie wyrazu np. trzech - /tSSex/,
                 * ale Czech - /tSex/, wodze  /vodze/, odzew  /od_zef/
                 */
        
                /*
                 * Spgoski bezdwiczne przed kocwk czasownikow my pozostaj bezdwiczne
                 * np.. kupmy - /kupmy/
                 */
        
        
        
        
    }
    
    /** Transkrypcja danego tekstu wedlug zgromadzonych regul
     */
    public Transkrybowane transkrypcja(String tekst) {
        
        String in = tekst.toLowerCase();    //tylko male litery
        Vector difony = new Vector();       //wynik podzial tekstu na znaczki sampa
        Sekwencjoner s = new Sekwencjoner(in);  //podaje kolejne znaki stringa wejsciowego
                
        reguly.porzadkuj();     //po dodaniu ostatniej reguly koniecznie tzreba je uporzadkowac        
        
//        //--
//        // wypisuje uporadkowane reguly
//        
//        for(int i=0; i<this.reguly.size(); i++) {
//            Regula r = this.reguly.get(i);  //aktualna regula
//            System.out.print(""+i+": "+r.getWzorzec()+" (waga:"+r.getWaga()+"; pozycja:"+r.getPrzesuniecie()+";) -> ");
//            for(int j=0; j<r.getIloscDifonow(); j++) {
//                System.out.print(" "+r.getDifon(j));
//            }
//            System.out.println("");
//        }
//        
//        //--
        
        while(s.isNotEmpty()) {     //dopoki sa zaki w sekwencjonerze
            
            for(int i=0; i<this.reguly.size(); i++) {   //podawaj kazda regule od najdluzszej do najkrotszej
                
                Regula r = this.reguly.get(i);  //aktualna regula
                
                String ciag = "";   //podciag wybrany z ciagu wejsciowego
                
                for(int j=0; j<r.getWzorzec().length(); j++) {  //wyciac tyle znakow ile znakow ma wzorzec reguly 
                   
                    ciag += ""+s.get(j+r.getPoczatek());    //wyciac o kilka do tylu jezeli potzrebuje tego regula                    
                }
                
                if(pasujeDoReguly(ciag, r.getWzorzec())) {   //jezeli ciagi sa rowne to znaczy ze mozemy zastosowac regule
                    
                    for(int k=0; k<r.getIloscDifonow(); k++) {  //zamieniamy ciag znakow na znaczki sampa, moze byc wiecej niz jeden
                        difony.add(r.getDifon(k));  //dodanie wszystkich znaczkow
                    }
                    
                    s.next(r.getPrzesuniecie()-1);    //przesuniecie o n znakow w sekwencjonerze
                    
                    break; //dalsze reguly juz nieprzetwarzane jezeli zastosowana jest jedna
                }
                
            }
            
            s.next(1);  //zawsze o jeden znak do przodu
            
        }
        
        // dodawanie pierwszej i ostatniej spacji jezeli jest taka potzreba
        
        String pierwszy = (String)difony.get(0);
        String ostatni = (String)difony.get(difony.size()-1);
        
        if(!pierwszy.equals("_") && !pierwszy.equals(".") && !pierwszy.equals("?") && !pierwszy.equals("!") && !pierwszy.equals(",")) {
            difony.add(0, "_");
        }
        
        if(!ostatni.equals("_") && !ostatni.equals(".") && !ostatni.equals("?") && !ostatni.equals("!") && !ostatni.equals(",")) {
            difony.add("_");
        }
        
        //podzielenie wejscia na zdania
        
        Stack<Integer> konce = new Stack<Integer>();
        Stack<Integer> intonacje = new Stack<Integer>();
        
        for(int i=0; i<difony.size(); i++) {
            
            String sd = (String)difony.get(i);
            
            if(sd.equals(".")) {
                
                konce.push(i+1);
                intonacje.push(Transkrybowane.ZDANIE_OZNAJMUJACE);
                
            } else if(sd.equals("?")) {
                
                konce.push(i+1);
                intonacje.push(Transkrybowane.ZDANIE_PYTAJACE);
                
            } else if(sd.equals("!")) {
                                
                konce.push(i+1);
                intonacje.push(Transkrybowane.ZDANIE_WYKRZYKNIKOWE);
                
            }
            
        }
        
        int[] tkonce = new int[konce.size()];
        int[] tintonacje = new int[intonacje.size()];
        
        while(konce.size()>0) {
            tkonce[konce.size()-1] = konce.pop();
            tintonacje[intonacje.size()-1] = intonacje.pop();
        }
        
        MaskaIntonacji mi = new MaskaIntonacji(tkonce, tintonacje);
              
//        int typ = 0; //typ zdania;
//        
//        char ostatniZnak = in.charAt(in.length()-1);    //ostatni znak w wejsciowym stringu
//        
//        switch(ostatniZnak) {
//            case '!': typ = Transkrybowane.ZDANIE_WYKRZYKNIKOWE; break;
//            case '.': typ = Transkrybowane.ZDANIE_OZNAJMUJACE; break;
//            case '?': typ = Transkrybowane.ZDANIE_PYTAJACE; break;
//            default:
//                typ = Transkrybowane.ZDANIE_OZNAJMUJACE;
//        }
        
        return new Transkrybowane(difony, mi);
        
    }
    
    private boolean pasujeDoReguly(String s1, String s2) {
        
        if(s1.length()!=s2.length()) return false;
        
        for(int i=0; i<s1.length(); i++) {
            if(s1.charAt(i)!=s2.charAt(i)) {
                
                char s1c = s1.charAt(i);
                char s2c = s2.charAt(i);
                
                if(s1c == ',' || s1c == '.' || s1c == '!' || s1c == '?') s1c = ' ';
                if(s2c == ',' || s2c == '.' || s2c == '!' || s2c == '?') s2c = ' ';
                
                if(s1c != s2c || (s1.length()==1 && s2.length()==1)) return false;
                
                //nie chcemy zamieniac spacji wiec odrzucamy jedynki
                //chodzi nam tylko o reguly tymu szos_ -> szosom
                //czyli wieloliterowe
            }
        }
        
        return true;        
    }
    
    public SampaEnginePanel getPanel() {
        return new SampaEnginePanel(this.reguly);
    }
    
    public ZarzadcaRegul getZarzadcaRegul() {
        return this.reguly;
    }
}

/** Klasa reprezentujaca reguly transkrypcji
 */
class Regula implements Comparable {
    
    /** Wzorzec ktory identyfikuje dana regue */
    private String wzorzec;
    /** Zamiennik ktory zamienia dany wzorzec */
    //private String zamiennik;
    private String[] difony;
    /** Przesuniecie znakow w transkrybowanym ciagu po zaaplikowanej regule */
    private int przesuniecie;
    /** Poczatek wzorca wzgledem aktualnej pozycji w transkrybowanym ciagu */
    private int poczatek;
    
    private int waga = 0;    
    
    /** Konstruktor reguly
     * okrelany przez wzorzec i zamiennik,
     * wartoci przesunicia i pocztku sa inicjalizowane automatycznie wedlug wzorca
     * <code>poczatek = 0;</code>
     * <code>przesuniecie = wzorzec.length();</code>
     */
    public Regula(String wzorzec, String[] zamiennik) {
        this.wzorzec = wzorzec;
        this.difony = zamiennik;
        this.przesuniecie = wzorzec.length();
        this.poczatek = 0;
    }
    
    /** Konstruktor reguly
     * okrelany przez poczatek, wzorzec i zamiennik,
     * warto przesunicia jest inicjalizowana automatycznie wedlug wzorca
     * <code>przesuniecie = wzorzec.length();</code>
     */
    public Regula(int poczatek, String wzorzec, String[] zamiennik) {
        this.wzorzec = wzorzec;
        this.difony = zamiennik;
        this.przesuniecie = wzorzec.length();
        this.poczatek = poczatek;
    }
    
    /** Konstruktor reguly
     * okrelany przez przesuniecie, wzorzec i zamiennik,
     * warto pocztka jest inicjalizowana automatycznie wedlug wzorca
     * <code>poczatek = 0;</code>
     */
    public Regula(String wzorzec, String[] zamiennik, int przesuniecie) {
        this.wzorzec = wzorzec;
        this.difony = zamiennik;
        this.przesuniecie = przesuniecie;
        this.poczatek = 0;
    }
    
    /** Konstruktor reguly
     * okrelany przez poczatek, przesuniecie, wzorzec i zamiennik,
     *
     * przykad: (** pokazuje gdzie znajduje sie aktualny znak w ciagu)
     *
     *   . . . *D* a n i a . .
     *   new Regula(0, "Danja", new String[]{"d", "a", "n", "j", "a"}, 5);
     *
     *   . . s i ** . .
     *   new Regula(-2, "si", new String[]{"e"}, 1);
     */
    public Regula(int poczatek, String wzorzec, String[] zamiennik, int przesuniecie) {
        this.wzorzec = wzorzec;
        this.difony = zamiennik;
        this.przesuniecie = przesuniecie;
        this.poczatek = poczatek;
    }
    
    /** Konstruktor reguly
     * okrelany przez poczatek, przesuniecie, wzorzec i zamiennik,
     *
     * przykad: (** pokazuje gdzie znajduje sie aktualny znak w ciagu)
     *
     *   . . . *D* a n i a . .
     *   new Regula(0, "Danja", new String[]{"d", "a", "n", "j", "a"}, 5);
     *
     *   . . s i ** . .
     *   new Regula(-2, "si", new String[]{"e"}, 1);
     */
    public Regula(int poczatek, String wzorzec, String[] zamiennik, int przesuniecie, int waga) {
        this.wzorzec = wzorzec;
        this.difony = zamiennik;
        this.przesuniecie = przesuniecie;
        this.poczatek = poczatek;
        this.waga = waga;
    }
    
//    public int size() {
//        return this.wzorzec.length();
//    }
    
    /** Zdefiniowanie porownywania regul, wieksza jest regula o wiekszym 
     * przesunieciu bufora w sekwencjonerze
     */
    public int compareTo(Object arg0) {
                
        //jezeli rowne to sprawdzana waga
        if(this.getWaga()<((Regula)arg0).getWaga()) {
            return -1;
        } else if(this.getWaga()>((Regula)arg0).getWaga()) {
            return 1;
        }
        
        if(this.getPrzesuniecie()<((Regula)arg0).getPrzesuniecie()) {
            return -1;
        } else if(this.getPrzesuniecie()>((Regula)arg0).getPrzesuniecie()) {
            return 1;
        }
        
        return 0;
    }
    
    public int getWaga() {
        return waga;
    }
    
    /** Zwraca pozycje poczatka reguly wzgledem aktualnej pozycji sekwencjonera
     */
    public int getPoczatek() {
        return poczatek;
    }
    
    /** Zwraca wzorzec reguly
     */
    public String getWzorzec() {
        return wzorzec;
    }
    
    /** Zwraca przesuniecie pozycji sekwencjonera
     */
    public int getPrzesuniecie() {
        return przesuniecie;
    }
    
//    public String getZamiennik() {
//        return zamiennik;
//    }
    
    /** Zwraca ilosc difonow na ktore rozkladany jest dany wzorzec
     */
    public int getIloscDifonow() {
        return this.difony.length;
    }
    
    /** Zwraca poszczegolne difony na ktore rozkladany jest dany wzorzec
     */
    public String getDifon(int n) {
        if(n<0 || n>=this.difony.length) {
            return "_";
        }
        return this.difony[n];
    }
    
}

/** Klasa podajaca kolejne znaki Stringa */
class Sekwencjoner {
    
    /** Przetwazany String*/
    private String s;
    /** Aktualna pozycja przetwarzania*/
    private int pozycja = 0;
    
    /** Tworzy nowy sekwencjoner
     */
    public Sekwencjoner(String s) {
        this.s = s;
        this.pozycja = 0;
    }
    
    /** Zwraca dany znak w sekwencjonerze, wzgledem aktualnego punktu przetwarzania
     */
    public char get(int n) {
        
        if((pozycja + n)<0 || (pozycja + n)>=s.length()) return ' ';
        
//        if(
//                this.s.charAt(pozycja + n) == '!' ||
//                this.s.charAt(pozycja + n) == '.' ||
//                this.s.charAt(pozycja + n) == '?')
//            return ' ';
        
        return this.s.charAt(pozycja + n);
    }
    
    /** Przesuwa pozycje aktualnego znaku w sekwencjonerze
     */
    public void next(int n) {
        pozycja+=n;
    }
    
    /** Flaga ustawiana gdy w sekwencjonerze nie ma juz nieodczytanych znakow
     */
    public boolean isNotEmpty() {
        if(pozycja<this.s.length()) return true;
        return false;
    }
}

/** Gromadzi i zarzadza dodanymi regulami */
class ZarzadcaRegul {
    
    /** Wektor regul */
    public Vector w;
    /** Porzadek regul w wektorze */
    public int[] porzadek;
    
    /** Tworzy nowego zarzadce regul
     */
    public ZarzadcaRegul() {
        this.w = new Vector();
    }    
    
    /** Dodaje nowa regule do zarzadcy
     */
    public void add(Regula r) {
        w.add(r);
        this.porzadkuj();
    }
    
    /** Pobiera dana regule z zarzadcy
     */
    public Regula get(int i) {
        if(this.porzadek == null || this.porzadek.length != this.w.size()) {
            this.porzadkuj();
        }
        
        return (Regula)w.get(this.porzadek[i]);
    }
    
    /**Usuwa dana regule z zarzadcy
     */
    public void remove(int i) {
        if(this.porzadek == null || this.porzadek.length != this.w.size()) {
            this.porzadkuj();
        }
        
        this.w.remove(this.porzadek[i]);
        this.porzadkuj();
    }   
    
    /**Usuwa dane reguly z zarzadcy
     */
    public void remove(int[] it) {
        if(this.porzadek == null || this.porzadek.length != this.w.size()) {
            this.porzadkuj();
        }
        
        for(int i=0; i<it.length; i++) {
            if(it[i]>=0 && it[i]<porzadek.length)
                this.w.remove(this.porzadek[it[i]]);                
        }
        
        this.porzadkuj();
    }
    
    /** Czysci wszystkie */
    public void removeAll() {
        this.w = new Vector();
        this.porzadek = null;
    }
    
    /**Zwraca ilosc regul w zarzadcy
     */
    public int size() {
        return this.w.size();
    }
    
    /** Porzadkuje reguly od najdluzszej do najkrotszej
     * tak aby te dluzsze byly przetwarzane jako pierwsze
     */
    public void porzadkuj() {
        this.porzadek = new int[this.w.size()];
        
        for(int i=0; i<this.porzadek.length; i++)
            this.porzadek[i] = i;
        
        for(int i=0; i<porzadek.length; i++) {
            for(int j=i+1; j<porzadek.length; j++) {
                
                if(((Regula)this.w.get(this.porzadek[i])).compareTo((Regula)this.w.get(this.porzadek[j]))<0) {
                    int tmp = this.porzadek[i];
                    this.porzadek[i] = this.porzadek[j];
                    this.porzadek[j] = tmp;
                }
                
            }
        }       

    }
}

